{$A-,B-,D+,E+,F-,I+,L+,N-,O-,R-,S-,V+}
{$M 20000,10000,655360}
PROGRAM PrefixToPostfix (Input, Output);

   TYPE OperandType = Integer;
        DigitType = 0..9;

   VAR InChar: Char;
       Hold: Boolean;
       OutFile: Text;

   PROCEDURE Initialize;

      BEGIN  (* Initialize *)
         Hold := False;
      END;   (* Initialize *)

   PROCEDURE GetChar (VAR Ch: Char);

      BEGIN  (* GetChar *)
         IF NOT Hold THEN
            Read (InChar)
               ELSE
                 Hold := False;

         Ch := InChar
      END;   (* GetChar *)

   PROCEDURE UnGetChar (Ch: Char);

      BEGIN  (* UnGetChar *)
         IF NOT Hold THEN
            BEGIN  (* push char back into the hold buffer *)
               InChar := Ch;
               Hold := True
            END    (* push char back into the hold buffer *)
      END;   (* UnGetChar *)


   FUNCTION Expr: String;

      VAR Operator: Char;
          Operand1, Operand2: String;
          Result: String;
          DummyChar: Char;


      PROCEDURE ReadOperand (VAR Operand: String);

         VAR Ch: Char;
             Result: String;
             Operators: SET OF Char;



         PROCEDURE ReadValue (VAR Value: String);

            VAR Result: String;
                Ch: Char;

                Digits: SET OF Char;

            BEGIN  (* ReadValue *)
               Digits := ['0'..'9'];

               Result := '';

               GetChar (Ch);

               WHILE Ch IN Digits DO
                  BEGIN   (* read number *)
                     Result := Result + Ch;
                     GetChar (Ch)
                  END;    (* read number *)

               Value := Result
            END;   (* ReadValue *)

         BEGIN  (* ReadOperand *)
            Operators := ['+','-','*','/'];

            GetChar (Ch);
            UnGetChar (Ch);

            IF Ch IN Operators THEN
               Result := Expr
                  ELSE
                     ReadValue (Result);

            Operand := Result

         END;   (* ReadOperand *)

      BEGIN  (* Expr *)
         GetChar (Operator);
         GetChar (DummyChar);
         ReadOperand (Operand1);
         ReadOperand (Operand2);

         Result := Operand1 + ' ' + Operand2 + ' ' + Operator;

         Expr := Result
      END;   (* Expr *)

   BEGIN  (* PrefixToPostfix *)
       WriteLn (Expr)
   END.   (* PrefixToPostfix *)
